#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 137
#define LARGE_STATE_COUNT 13
#define SYMBOL_COUNT 76
#define ALIAS_COUNT 2
#define TOKEN_COUNT 47
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 15

enum ts_symbol_identifiers {
  anon_sym_PIPE = 1,
  sym_any_character = 2,
  anon_sym_CARET = 3,
  sym_end_assertion = 4,
  sym_boundary_assertion = 5,
  sym_non_boundary_assertion = 6,
  anon_sym_LPAREN_QMARK = 7,
  anon_sym_EQ = 8,
  anon_sym_BANG = 9,
  anon_sym_RPAREN = 10,
  anon_sym_LPAREN_QMARK_LT = 11,
  sym_pattern_character = 12,
  anon_sym_LBRACK = 13,
  anon_sym_DASH = 14,
  anon_sym_RBRACK = 15,
  anon_sym_LBRACK_COLON = 16,
  anon_sym_COLON_RBRACK = 17,
  aux_sym_posix_class_name_token1 = 18,
  anon_sym_BSLASH_DASH = 19,
  sym_class_character = 20,
  anon_sym_LPAREN = 21,
  anon_sym_LPAREN_QMARKP_LT = 22,
  anon_sym_GT = 23,
  anon_sym_LPAREN_QMARK_COLON = 24,
  anon_sym_COLON = 25,
  anon_sym_STAR = 26,
  anon_sym_QMARK = 27,
  anon_sym_PLUS = 28,
  anon_sym_LBRACE = 29,
  anon_sym_COMMA = 30,
  anon_sym_RBRACE = 31,
  anon_sym_BSLASHk = 32,
  anon_sym_LT = 33,
  anon_sym_LPAREN_QMARKP_EQ = 34,
  sym_decimal_escape = 35,
  aux_sym_character_class_escape_token1 = 36,
  aux_sym_character_class_escape_token2 = 37,
  aux_sym_unicode_character_escape_token1 = 38,
  aux_sym_unicode_character_escape_token2 = 39,
  sym_unicode_property = 40,
  aux_sym_control_escape_token1 = 41,
  aux_sym_control_escape_token2 = 42,
  sym_control_letter_escape = 43,
  sym_identity_escape = 44,
  sym_group_name = 45,
  sym_decimal_digits = 46,
  sym_pattern = 47,
  sym_alternation = 48,
  sym_term = 49,
  sym_start_assertion = 50,
  sym_lookaround_assertion = 51,
  sym__lookahead_assertion = 52,
  sym__lookbehind_assertion = 53,
  sym_character_class = 54,
  sym_posix_character_class = 55,
  sym_posix_class_name = 56,
  sym_class_range = 57,
  sym_anonymous_capturing_group = 58,
  sym_named_capturing_group = 59,
  sym_non_capturing_group = 60,
  sym_inline_flags_group = 61,
  sym_flags = 62,
  sym_zero_or_more = 63,
  sym_one_or_more = 64,
  sym_optional = 65,
  sym_count_quantifier = 66,
  sym_backreference_escape = 67,
  sym_named_group_backreference = 68,
  sym_character_class_escape = 69,
  sym_unicode_character_escape = 70,
  sym_unicode_property_value_expression = 71,
  sym_control_escape = 72,
  aux_sym_alternation_repeat1 = 73,
  aux_sym_term_repeat1 = 74,
  aux_sym_character_class_repeat1 = 75,
  alias_sym_lazy = 76,
  alias_sym_unicode_property_name = 77,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_PIPE] = "|",
  [sym_any_character] = "any_character",
  [anon_sym_CARET] = "^",
  [sym_end_assertion] = "end_assertion",
  [sym_boundary_assertion] = "boundary_assertion",
  [sym_non_boundary_assertion] = "non_boundary_assertion",
  [anon_sym_LPAREN_QMARK] = "(\?",
  [anon_sym_EQ] = "=",
  [anon_sym_BANG] = "!",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LPAREN_QMARK_LT] = "(\?<",
  [sym_pattern_character] = "pattern_character",
  [anon_sym_LBRACK] = "[",
  [anon_sym_DASH] = "-",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_COLON] = "[:",
  [anon_sym_COLON_RBRACK] = ":]",
  [aux_sym_posix_class_name_token1] = "posix_class_name_token1",
  [anon_sym_BSLASH_DASH] = "identity_escape",
  [sym_class_character] = "class_character",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LPAREN_QMARKP_LT] = "(\?P<",
  [anon_sym_GT] = ">",
  [anon_sym_LPAREN_QMARK_COLON] = "(\?:",
  [anon_sym_COLON] = ":",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "\?",
  [anon_sym_PLUS] = "+",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_BSLASHk] = "\\k",
  [anon_sym_LT] = "<",
  [anon_sym_LPAREN_QMARKP_EQ] = "(\?P=",
  [sym_decimal_escape] = "decimal_escape",
  [aux_sym_character_class_escape_token1] = "character_class_escape_token1",
  [aux_sym_character_class_escape_token2] = "character_class_escape_token2",
  [aux_sym_unicode_character_escape_token1] = "unicode_character_escape_token1",
  [aux_sym_unicode_character_escape_token2] = "unicode_character_escape_token2",
  [sym_unicode_property] = "unicode_property_value",
  [aux_sym_control_escape_token1] = "control_escape_token1",
  [aux_sym_control_escape_token2] = "control_escape_token2",
  [sym_control_letter_escape] = "control_letter_escape",
  [sym_identity_escape] = "identity_escape",
  [sym_group_name] = "group_name",
  [sym_decimal_digits] = "decimal_digits",
  [sym_pattern] = "pattern",
  [sym_alternation] = "alternation",
  [sym_term] = "term",
  [sym_start_assertion] = "start_assertion",
  [sym_lookaround_assertion] = "lookaround_assertion",
  [sym__lookahead_assertion] = "_lookahead_assertion",
  [sym__lookbehind_assertion] = "_lookbehind_assertion",
  [sym_character_class] = "character_class",
  [sym_posix_character_class] = "posix_character_class",
  [sym_posix_class_name] = "posix_class_name",
  [sym_class_range] = "class_range",
  [sym_anonymous_capturing_group] = "anonymous_capturing_group",
  [sym_named_capturing_group] = "named_capturing_group",
  [sym_non_capturing_group] = "non_capturing_group",
  [sym_inline_flags_group] = "inline_flags_group",
  [sym_flags] = "flags",
  [sym_zero_or_more] = "zero_or_more",
  [sym_one_or_more] = "one_or_more",
  [sym_optional] = "optional",
  [sym_count_quantifier] = "count_quantifier",
  [sym_backreference_escape] = "backreference_escape",
  [sym_named_group_backreference] = "named_group_backreference",
  [sym_character_class_escape] = "character_class_escape",
  [sym_unicode_character_escape] = "unicode_character_escape",
  [sym_unicode_property_value_expression] = "unicode_property_value_expression",
  [sym_control_escape] = "control_escape",
  [aux_sym_alternation_repeat1] = "alternation_repeat1",
  [aux_sym_term_repeat1] = "term_repeat1",
  [aux_sym_character_class_repeat1] = "character_class_repeat1",
  [alias_sym_lazy] = "lazy",
  [alias_sym_unicode_property_name] = "unicode_property_name",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [sym_any_character] = sym_any_character,
  [anon_sym_CARET] = anon_sym_CARET,
  [sym_end_assertion] = sym_end_assertion,
  [sym_boundary_assertion] = sym_boundary_assertion,
  [sym_non_boundary_assertion] = sym_non_boundary_assertion,
  [anon_sym_LPAREN_QMARK] = anon_sym_LPAREN_QMARK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LPAREN_QMARK_LT] = anon_sym_LPAREN_QMARK_LT,
  [sym_pattern_character] = sym_pattern_character,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACK_COLON] = anon_sym_LBRACK_COLON,
  [anon_sym_COLON_RBRACK] = anon_sym_COLON_RBRACK,
  [aux_sym_posix_class_name_token1] = aux_sym_posix_class_name_token1,
  [anon_sym_BSLASH_DASH] = sym_identity_escape,
  [sym_class_character] = sym_class_character,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_LPAREN_QMARKP_LT] = anon_sym_LPAREN_QMARKP_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LPAREN_QMARK_COLON] = anon_sym_LPAREN_QMARK_COLON,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_BSLASHk] = anon_sym_BSLASHk,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LPAREN_QMARKP_EQ] = anon_sym_LPAREN_QMARKP_EQ,
  [sym_decimal_escape] = sym_decimal_escape,
  [aux_sym_character_class_escape_token1] = aux_sym_character_class_escape_token1,
  [aux_sym_character_class_escape_token2] = aux_sym_character_class_escape_token2,
  [aux_sym_unicode_character_escape_token1] = aux_sym_unicode_character_escape_token1,
  [aux_sym_unicode_character_escape_token2] = aux_sym_unicode_character_escape_token2,
  [sym_unicode_property] = sym_unicode_property,
  [aux_sym_control_escape_token1] = aux_sym_control_escape_token1,
  [aux_sym_control_escape_token2] = aux_sym_control_escape_token2,
  [sym_control_letter_escape] = sym_control_letter_escape,
  [sym_identity_escape] = sym_identity_escape,
  [sym_group_name] = sym_group_name,
  [sym_decimal_digits] = sym_decimal_digits,
  [sym_pattern] = sym_pattern,
  [sym_alternation] = sym_alternation,
  [sym_term] = sym_term,
  [sym_start_assertion] = sym_start_assertion,
  [sym_lookaround_assertion] = sym_lookaround_assertion,
  [sym__lookahead_assertion] = sym__lookahead_assertion,
  [sym__lookbehind_assertion] = sym__lookbehind_assertion,
  [sym_character_class] = sym_character_class,
  [sym_posix_character_class] = sym_posix_character_class,
  [sym_posix_class_name] = sym_posix_class_name,
  [sym_class_range] = sym_class_range,
  [sym_anonymous_capturing_group] = sym_anonymous_capturing_group,
  [sym_named_capturing_group] = sym_named_capturing_group,
  [sym_non_capturing_group] = sym_non_capturing_group,
  [sym_inline_flags_group] = sym_inline_flags_group,
  [sym_flags] = sym_flags,
  [sym_zero_or_more] = sym_zero_or_more,
  [sym_one_or_more] = sym_one_or_more,
  [sym_optional] = sym_optional,
  [sym_count_quantifier] = sym_count_quantifier,
  [sym_backreference_escape] = sym_backreference_escape,
  [sym_named_group_backreference] = sym_named_group_backreference,
  [sym_character_class_escape] = sym_character_class_escape,
  [sym_unicode_character_escape] = sym_unicode_character_escape,
  [sym_unicode_property_value_expression] = sym_unicode_property_value_expression,
  [sym_control_escape] = sym_control_escape,
  [aux_sym_alternation_repeat1] = aux_sym_alternation_repeat1,
  [aux_sym_term_repeat1] = aux_sym_term_repeat1,
  [aux_sym_character_class_repeat1] = aux_sym_character_class_repeat1,
  [alias_sym_lazy] = alias_sym_lazy,
  [alias_sym_unicode_property_name] = alias_sym_unicode_property_name,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [sym_any_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [sym_end_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_non_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_QMARK_LT] = {
    .visible = true,
    .named = false,
  },
  [sym_pattern_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_posix_class_name_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASH_DASH] = {
    .visible = true,
    .named = true,
  },
  [sym_class_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_QMARKP_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHk] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_QMARKP_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym_decimal_escape] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_character_class_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_class_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_character_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_character_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_unicode_property] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_control_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_control_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_control_letter_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_identity_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_group_name] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_digits] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_alternation] = {
    .visible = true,
    .named = true,
  },
  [sym_term] = {
    .visible = true,
    .named = true,
  },
  [sym_start_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_lookaround_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym__lookahead_assertion] = {
    .visible = false,
    .named = true,
  },
  [sym__lookbehind_assertion] = {
    .visible = false,
    .named = true,
  },
  [sym_character_class] = {
    .visible = true,
    .named = true,
  },
  [sym_posix_character_class] = {
    .visible = true,
    .named = true,
  },
  [sym_posix_class_name] = {
    .visible = true,
    .named = true,
  },
  [sym_class_range] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_named_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_non_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_flags_group] = {
    .visible = true,
    .named = true,
  },
  [sym_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_zero_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_one_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_optional] = {
    .visible = true,
    .named = true,
  },
  [sym_count_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym_backreference_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_named_group_backreference] = {
    .visible = true,
    .named = true,
  },
  [sym_character_class_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_unicode_character_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_unicode_property_value_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_control_escape] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_alternation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_term_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_class_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_lazy] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_unicode_property_name] = {
    .visible = true,
    .named = true,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [1] = alias_sym_lazy,
  },
  [2] = {
    [1] = sym_class_character,
  },
  [3] = {
    [2] = sym_class_character,
  },
  [4] = {
    [0] = sym_class_character,
    [2] = sym_class_character,
  },
  [5] = {
    [1] = sym_class_character,
    [2] = sym_class_character,
  },
  [6] = {
    [0] = sym_class_character,
  },
  [7] = {
    [3] = alias_sym_lazy,
  },
  [8] = {
    [2] = sym_class_character,
    [3] = sym_class_character,
  },
  [9] = {
    [3] = sym_class_character,
  },
  [10] = {
    [1] = sym_class_character,
    [3] = sym_class_character,
  },
  [11] = {
    [0] = alias_sym_unicode_property_name,
  },
  [12] = {
    [4] = alias_sym_lazy,
  },
  [13] = {
    [2] = sym_class_character,
    [4] = sym_class_character,
  },
  [14] = {
    [5] = alias_sym_lazy,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 27,
  [73] = 73,
  [74] = 14,
  [75] = 15,
  [76] = 22,
  [77] = 34,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 92,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 96,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 115,
  [133] = 116,
  [134] = 134,
  [135] = 135,
  [136] = 111,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(34);
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(29);
      if (lookahead == '!') ADVANCE(43);
      if (lookahead == '$') ADVANCE(38);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(44);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(67);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(36);
      if (lookahead == ':') ADVANCE(64);
      if (lookahead == '<') ADVANCE(72);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(61);
      if (lookahead == '?') ADVANCE(66);
      if (lookahead == '[') ADVANCE(47);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(49);
      if (lookahead == '^') ADVANCE(37);
      if (lookahead == '{') ADVANCE(68);
      if (lookahead == '|') ADVANCE(35);
      if (lookahead == '}') ADVANCE(70);
      if (lookahead != 0) ADVANCE(46);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(55);
      if (lookahead == '\r') ADVANCE(54);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '[') ADVANCE(58);
      if (lookahead == '\\') ADVANCE(11);
      if (lookahead == ']') ADVANCE(49);
      if (lookahead == '^') ADVANCE(37);
      if (lookahead != 0) ADVANCE(54);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(56);
      if (lookahead == '\r') ADVANCE(54);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '[') ADVANCE(58);
      if (lookahead == '\\') ADVANCE(11);
      if (lookahead == ']') ADVANCE(49);
      if (lookahead != 0) ADVANCE(54);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(57);
      if (lookahead == '\r') ADVANCE(54);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == ']') ADVANCE(49);
      if (lookahead != 0) ADVANCE(54);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(5);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(5);
      if (lookahead == '\r') SKIP(4);
      if (lookahead == '!') ADVANCE(43);
      if (lookahead == ')') ADVANCE(44);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == ':') ADVANCE(63);
      if (lookahead == '<') ADVANCE(72);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '>') ADVANCE(61);
      if (lookahead == ']') ADVANCE(49);
      if (lookahead == '}') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(52);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(7);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(7);
      if (lookahead == '\r') SKIP(6);
      if (lookahead == '!') ADVANCE(43);
      if (lookahead == ':') ADVANCE(14);
      if (lookahead == '=') ADVANCE(42);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(87);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(9);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(9);
      if (lookahead == '\r') SKIP(8);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(79);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '-', 53,
        'B', 40,
        'b', 39,
        'c', 86,
        'k', 71,
        'u', 84,
        'x', 85,
        'P', 76,
        'p', 76,
        '0', 80,
        'f', 80,
        'n', 80,
        'r', 80,
        't', 80,
        'v', 80,
        'D', 75,
        'S', 75,
        'W', 75,
        'd', 75,
        's', 75,
        'w', 75,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (lookahead != 0) ADVANCE(83);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '-', 53,
        'c', 86,
        'u', 84,
        'x', 85,
        'P', 76,
        'p', 76,
        'D', 75,
        'S', 75,
        'W', 75,
        'd', 75,
        's', 75,
        'w', 75,
        '0', 80,
        'b', 80,
        'f', 80,
        'n', 80,
        'r', 80,
        't', 80,
        'v', 80,
      );
      if (lookahead != 0 &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != 'k') ADVANCE(83);
      END_STATE();
    case 12:
      if (lookahead == '<') ADVANCE(60);
      if (lookahead == '=') ADVANCE(73);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        'B', 40,
        'b', 39,
        'c', 86,
        'k', 71,
        'u', 84,
        'x', 85,
        'P', 76,
        'p', 76,
        '0', 80,
        'f', 80,
        'n', 80,
        'r', 80,
        't', 80,
        'v', 80,
        'D', 75,
        'S', 75,
        'W', 75,
        'd', 75,
        's', 75,
        'w', 75,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(74);
      if (lookahead != 0) ADVANCE(83);
      END_STATE();
    case 14:
      if (lookahead == ']') ADVANCE(51);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        'u', 16,
        'x', 26,
        'P', 76,
        'p', 76,
        'D', 75,
        'S', 75,
        'W', 75,
        'd', 75,
        's', 75,
        'w', 75,
        '0', 80,
        'b', 80,
        'f', 80,
        'n', 80,
        'r', 80,
        't', 80,
        'v', 80,
      );
      END_STATE();
    case 16:
      if (lookahead == '{') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(28);
      END_STATE();
    case 17:
      if (lookahead == '}') ADVANCE(78);
      END_STATE();
    case 18:
      if (lookahead == '}') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(17);
      END_STATE();
    case 19:
      if (lookahead == '}') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 20:
      if (lookahead == '}') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 21:
      if (lookahead == '}') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(20);
      END_STATE();
    case 22:
      if (lookahead == '}') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(21);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(22);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(81);
      END_STATE();
    case 25:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      END_STATE();
    case 26:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 27:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(25);
      END_STATE();
    case 28:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 29:
      if (eof) ADVANCE(34);
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 30:
      if (eof) ADVANCE(34);
      if (lookahead == '\n') SKIP(31);
      END_STATE();
    case 31:
      if (eof) ADVANCE(34);
      if (lookahead == '\n') SKIP(31);
      if (lookahead == '\r') SKIP(30);
      if (lookahead == '$') ADVANCE(38);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(44);
      if (lookahead == '.') ADVANCE(36);
      if (lookahead == '?') ADVANCE(66);
      if (lookahead == '[') ADVANCE(47);
      if (lookahead == '\\') ADVANCE(13);
      if (lookahead == '^') ADVANCE(37);
      if (lookahead == '|') ADVANCE(35);
      if (lookahead != 0 &&
          (lookahead < '(' || '+' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(46);
      END_STATE();
    case 32:
      if (eof) ADVANCE(34);
      if (lookahead == '\n') SKIP(33);
      END_STATE();
    case 33:
      if (eof) ADVANCE(34);
      if (lookahead == '\n') SKIP(33);
      if (lookahead == '\r') SKIP(32);
      if (lookahead == '$') ADVANCE(38);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(44);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(67);
      if (lookahead == '.') ADVANCE(36);
      if (lookahead == '?') ADVANCE(66);
      if (lookahead == '[') ADVANCE(47);
      if (lookahead == '\\') ADVANCE(13);
      if (lookahead == '^') ADVANCE(37);
      if (lookahead == '{') ADVANCE(68);
      if (lookahead == '|') ADVANCE(35);
      if (lookahead != 0 &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(46);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_any_character);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_end_assertion);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_boundary_assertion);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym_non_boundary_assertion);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARK);
      if (lookahead == ':') ADVANCE(62);
      if (lookahead == '<') ADVANCE(45);
      if (lookahead == 'P') ADVANCE(12);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARK_LT);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_pattern_character);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ':') ADVANCE(50);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_LBRACK_COLON);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_COLON_RBRACK);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_posix_class_name_token1);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(52);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_BSLASH_DASH);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_class_character);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_class_character);
      if (lookahead == '\n') ADVANCE(55);
      if (lookahead == '\r') ADVANCE(54);
      if (lookahead == '[') ADVANCE(58);
      if (lookahead == '^') ADVANCE(37);
      if (lookahead != 0 &&
          lookahead != '-' &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(54);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_class_character);
      if (lookahead == '\n') ADVANCE(56);
      if (lookahead == '\r') ADVANCE(54);
      if (lookahead == '[') ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '-' &&
          (lookahead < '[' || ']' < lookahead)) ADVANCE(54);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_class_character);
      if (lookahead == '\n') ADVANCE(57);
      if (lookahead == '\r') ADVANCE(54);
      if (lookahead != 0 &&
          lookahead != '-' &&
          lookahead != '\\' &&
          lookahead != ']') ADVANCE(54);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_class_character);
      if (lookahead == ':') ADVANCE(50);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '?') ADVANCE(41);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARKP_LT);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARK_COLON);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ']') ADVANCE(51);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_BSLASHk);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARKP_EQ);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_decimal_escape);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_character_class_escape_token1);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_character_class_escape_token2);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(aux_sym_unicode_character_escape_token1);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(aux_sym_unicode_character_escape_token2);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_unicode_property);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(79);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(aux_sym_control_escape_token1);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(aux_sym_control_escape_token2);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_control_letter_escape);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_identity_escape);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_identity_escape);
      if (lookahead == '{') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(28);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_identity_escape);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_identity_escape);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(82);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_group_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(87);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_decimal_digits);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 31},
  [2] = {.lex_state = 31},
  [3] = {.lex_state = 31},
  [4] = {.lex_state = 31},
  [5] = {.lex_state = 31},
  [6] = {.lex_state = 31},
  [7] = {.lex_state = 31},
  [8] = {.lex_state = 31},
  [9] = {.lex_state = 31},
  [10] = {.lex_state = 31},
  [11] = {.lex_state = 31},
  [12] = {.lex_state = 31},
  [13] = {.lex_state = 33},
  [14] = {.lex_state = 33},
  [15] = {.lex_state = 33},
  [16] = {.lex_state = 33},
  [17] = {.lex_state = 33},
  [18] = {.lex_state = 33},
  [19] = {.lex_state = 33},
  [20] = {.lex_state = 33},
  [21] = {.lex_state = 33},
  [22] = {.lex_state = 33},
  [23] = {.lex_state = 33},
  [24] = {.lex_state = 33},
  [25] = {.lex_state = 33},
  [26] = {.lex_state = 33},
  [27] = {.lex_state = 33},
  [28] = {.lex_state = 33},
  [29] = {.lex_state = 33},
  [30] = {.lex_state = 33},
  [31] = {.lex_state = 33},
  [32] = {.lex_state = 33},
  [33] = {.lex_state = 33},
  [34] = {.lex_state = 33},
  [35] = {.lex_state = 33},
  [36] = {.lex_state = 33},
  [37] = {.lex_state = 33},
  [38] = {.lex_state = 33},
  [39] = {.lex_state = 33},
  [40] = {.lex_state = 33},
  [41] = {.lex_state = 33},
  [42] = {.lex_state = 33},
  [43] = {.lex_state = 33},
  [44] = {.lex_state = 33},
  [45] = {.lex_state = 31},
  [46] = {.lex_state = 31},
  [47] = {.lex_state = 31},
  [48] = {.lex_state = 31},
  [49] = {.lex_state = 31},
  [50] = {.lex_state = 31},
  [51] = {.lex_state = 31},
  [52] = {.lex_state = 31},
  [53] = {.lex_state = 31},
  [54] = {.lex_state = 31},
  [55] = {.lex_state = 31},
  [56] = {.lex_state = 31},
  [57] = {.lex_state = 31},
  [58] = {.lex_state = 1},
  [59] = {.lex_state = 2},
  [60] = {.lex_state = 2},
  [61] = {.lex_state = 2},
  [62] = {.lex_state = 2},
  [63] = {.lex_state = 2},
  [64] = {.lex_state = 2},
  [65] = {.lex_state = 2},
  [66] = {.lex_state = 2},
  [67] = {.lex_state = 2},
  [68] = {.lex_state = 2},
  [69] = {.lex_state = 2},
  [70] = {.lex_state = 2},
  [71] = {.lex_state = 2},
  [72] = {.lex_state = 2},
  [73] = {.lex_state = 2},
  [74] = {.lex_state = 2},
  [75] = {.lex_state = 2},
  [76] = {.lex_state = 2},
  [77] = {.lex_state = 2},
  [78] = {.lex_state = 3},
  [79] = {.lex_state = 3},
  [80] = {.lex_state = 3},
  [81] = {.lex_state = 3},
  [82] = {.lex_state = 5},
  [83] = {.lex_state = 0},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 0},
  [86] = {.lex_state = 0},
  [87] = {.lex_state = 5},
  [88] = {.lex_state = 7},
  [89] = {.lex_state = 0},
  [90] = {.lex_state = 5},
  [91] = {.lex_state = 0},
  [92] = {.lex_state = 9},
  [93] = {.lex_state = 5},
  [94] = {.lex_state = 9},
  [95] = {.lex_state = 5},
  [96] = {.lex_state = 5},
  [97] = {.lex_state = 5},
  [98] = {.lex_state = 5},
  [99] = {.lex_state = 5},
  [100] = {.lex_state = 5},
  [101] = {.lex_state = 5},
  [102] = {.lex_state = 5},
  [103] = {.lex_state = 5},
  [104] = {.lex_state = 5},
  [105] = {.lex_state = 5},
  [106] = {.lex_state = 5},
  [107] = {.lex_state = 5},
  [108] = {.lex_state = 0},
  [109] = {.lex_state = 0},
  [110] = {.lex_state = 0},
  [111] = {.lex_state = 0},
  [112] = {.lex_state = 5},
  [113] = {.lex_state = 7},
  [114] = {.lex_state = 0},
  [115] = {.lex_state = 7},
  [116] = {.lex_state = 5},
  [117] = {.lex_state = 5},
  [118] = {.lex_state = 5},
  [119] = {.lex_state = 5},
  [120] = {.lex_state = 5},
  [121] = {.lex_state = 5},
  [122] = {.lex_state = 0},
  [123] = {.lex_state = 0},
  [124] = {.lex_state = 7},
  [125] = {.lex_state = 9},
  [126] = {.lex_state = 0},
  [127] = {.lex_state = 0},
  [128] = {.lex_state = 0},
  [129] = {.lex_state = 0},
  [130] = {.lex_state = 5},
  [131] = {.lex_state = 7},
  [132] = {.lex_state = 7},
  [133] = {.lex_state = 5},
  [134] = {.lex_state = 5},
  [135] = {.lex_state = 7},
  [136] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [sym_any_character] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [sym_end_assertion] = ACTIONS(1),
    [sym_boundary_assertion] = ACTIONS(1),
    [sym_non_boundary_assertion] = ACTIONS(1),
    [anon_sym_LPAREN_QMARK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(1),
    [sym_pattern_character] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_COLON] = ACTIONS(1),
    [anon_sym_COLON_RBRACK] = ACTIONS(1),
    [anon_sym_BSLASH_DASH] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_BSLASHk] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(1),
    [sym_decimal_escape] = ACTIONS(1),
    [aux_sym_character_class_escape_token1] = ACTIONS(1),
    [aux_sym_character_class_escape_token2] = ACTIONS(1),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(1),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(1),
    [aux_sym_control_escape_token1] = ACTIONS(1),
    [aux_sym_control_escape_token2] = ACTIONS(1),
    [sym_control_letter_escape] = ACTIONS(1),
    [sym_identity_escape] = ACTIONS(1),
  },
  [1] = {
    [sym_pattern] = STATE(129),
    [sym_alternation] = STATE(91),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_named_group_backreference] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(14),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(86),
    [aux_sym_term_repeat1] = STATE(11),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(21),
    [anon_sym_BSLASHk] = ACTIONS(23),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(27),
    [aux_sym_character_class_escape_token2] = ACTIONS(29),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(31),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(31),
    [aux_sym_control_escape_token1] = ACTIONS(33),
    [aux_sym_control_escape_token2] = ACTIONS(35),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(37),
  },
  [2] = {
    [sym_pattern] = STATE(126),
    [sym_alternation] = STATE(91),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_named_group_backreference] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(14),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(86),
    [aux_sym_term_repeat1] = STATE(11),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(21),
    [anon_sym_BSLASHk] = ACTIONS(23),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(27),
    [aux_sym_character_class_escape_token2] = ACTIONS(29),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(31),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(31),
    [aux_sym_control_escape_token1] = ACTIONS(33),
    [aux_sym_control_escape_token2] = ACTIONS(35),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(37),
  },
  [3] = {
    [sym_pattern] = STATE(108),
    [sym_alternation] = STATE(91),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_named_group_backreference] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(14),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(86),
    [aux_sym_term_repeat1] = STATE(11),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(21),
    [anon_sym_BSLASHk] = ACTIONS(23),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(27),
    [aux_sym_character_class_escape_token2] = ACTIONS(29),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(31),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(31),
    [aux_sym_control_escape_token1] = ACTIONS(33),
    [aux_sym_control_escape_token2] = ACTIONS(35),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(37),
  },
  [4] = {
    [sym_pattern] = STATE(110),
    [sym_alternation] = STATE(91),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_named_group_backreference] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(14),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(86),
    [aux_sym_term_repeat1] = STATE(11),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(21),
    [anon_sym_BSLASHk] = ACTIONS(23),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(27),
    [aux_sym_character_class_escape_token2] = ACTIONS(29),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(31),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(31),
    [aux_sym_control_escape_token1] = ACTIONS(33),
    [aux_sym_control_escape_token2] = ACTIONS(35),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(37),
  },
  [5] = {
    [sym_pattern] = STATE(127),
    [sym_alternation] = STATE(91),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_named_group_backreference] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(14),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(86),
    [aux_sym_term_repeat1] = STATE(11),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(21),
    [anon_sym_BSLASHk] = ACTIONS(23),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(27),
    [aux_sym_character_class_escape_token2] = ACTIONS(29),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(31),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(31),
    [aux_sym_control_escape_token1] = ACTIONS(33),
    [aux_sym_control_escape_token2] = ACTIONS(35),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(37),
  },
  [6] = {
    [sym_pattern] = STATE(109),
    [sym_alternation] = STATE(91),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_named_group_backreference] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(14),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(86),
    [aux_sym_term_repeat1] = STATE(11),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(21),
    [anon_sym_BSLASHk] = ACTIONS(23),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(27),
    [aux_sym_character_class_escape_token2] = ACTIONS(29),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(31),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(31),
    [aux_sym_control_escape_token1] = ACTIONS(33),
    [aux_sym_control_escape_token2] = ACTIONS(35),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(37),
  },
  [7] = {
    [sym_pattern] = STATE(122),
    [sym_alternation] = STATE(91),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_named_group_backreference] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(14),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(86),
    [aux_sym_term_repeat1] = STATE(11),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(21),
    [anon_sym_BSLASHk] = ACTIONS(23),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(27),
    [aux_sym_character_class_escape_token2] = ACTIONS(29),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(31),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(31),
    [aux_sym_control_escape_token1] = ACTIONS(33),
    [aux_sym_control_escape_token2] = ACTIONS(35),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(37),
  },
  [8] = {
    [sym_pattern] = STATE(128),
    [sym_alternation] = STATE(91),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_named_group_backreference] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(14),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(86),
    [aux_sym_term_repeat1] = STATE(11),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(21),
    [anon_sym_BSLASHk] = ACTIONS(23),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(27),
    [aux_sym_character_class_escape_token2] = ACTIONS(29),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(31),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(31),
    [aux_sym_control_escape_token1] = ACTIONS(33),
    [aux_sym_control_escape_token2] = ACTIONS(35),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(37),
  },
  [9] = {
    [sym_pattern] = STATE(123),
    [sym_alternation] = STATE(91),
    [sym_term] = STATE(85),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_named_group_backreference] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(14),
    [sym_control_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(86),
    [aux_sym_term_repeat1] = STATE(11),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(21),
    [anon_sym_BSLASHk] = ACTIONS(23),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(27),
    [aux_sym_character_class_escape_token2] = ACTIONS(29),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(31),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(31),
    [aux_sym_control_escape_token1] = ACTIONS(33),
    [aux_sym_control_escape_token2] = ACTIONS(35),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(37),
  },
  [10] = {
    [sym_term] = STATE(89),
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_named_group_backreference] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(14),
    [sym_control_escape] = STATE(13),
    [aux_sym_term_repeat1] = STATE(11),
    [ts_builtin_sym_end] = ACTIONS(39),
    [anon_sym_PIPE] = ACTIONS(39),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_RPAREN] = ACTIONS(39),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(21),
    [anon_sym_BSLASHk] = ACTIONS(23),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(27),
    [aux_sym_character_class_escape_token2] = ACTIONS(29),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(31),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(31),
    [aux_sym_control_escape_token1] = ACTIONS(33),
    [aux_sym_control_escape_token2] = ACTIONS(35),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(37),
  },
  [11] = {
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_named_group_backreference] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(14),
    [sym_control_escape] = STATE(13),
    [aux_sym_term_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(41),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_RPAREN] = ACTIONS(41),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(21),
    [anon_sym_BSLASHk] = ACTIONS(23),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(27),
    [aux_sym_character_class_escape_token2] = ACTIONS(29),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(31),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(31),
    [aux_sym_control_escape_token1] = ACTIONS(33),
    [aux_sym_control_escape_token2] = ACTIONS(35),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(37),
  },
  [12] = {
    [sym_start_assertion] = STATE(13),
    [sym_lookaround_assertion] = STATE(13),
    [sym__lookahead_assertion] = STATE(16),
    [sym__lookbehind_assertion] = STATE(16),
    [sym_character_class] = STATE(13),
    [sym_posix_character_class] = STATE(13),
    [sym_anonymous_capturing_group] = STATE(13),
    [sym_named_capturing_group] = STATE(13),
    [sym_non_capturing_group] = STATE(13),
    [sym_inline_flags_group] = STATE(13),
    [sym_backreference_escape] = STATE(13),
    [sym_named_group_backreference] = STATE(13),
    [sym_character_class_escape] = STATE(13),
    [sym_unicode_character_escape] = STATE(14),
    [sym_control_escape] = STATE(13),
    [aux_sym_term_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(43),
    [anon_sym_PIPE] = ACTIONS(43),
    [sym_any_character] = ACTIONS(45),
    [anon_sym_CARET] = ACTIONS(48),
    [sym_end_assertion] = ACTIONS(45),
    [sym_boundary_assertion] = ACTIONS(45),
    [sym_non_boundary_assertion] = ACTIONS(45),
    [anon_sym_LPAREN_QMARK] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(43),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(54),
    [sym_pattern_character] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_COLON] = ACTIONS(60),
    [anon_sym_LPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_QMARKP_LT] = ACTIONS(66),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(69),
    [anon_sym_BSLASHk] = ACTIONS(72),
    [anon_sym_LPAREN_QMARKP_EQ] = ACTIONS(75),
    [sym_decimal_escape] = ACTIONS(45),
    [aux_sym_character_class_escape_token1] = ACTIONS(78),
    [aux_sym_character_class_escape_token2] = ACTIONS(81),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(84),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(84),
    [aux_sym_control_escape_token1] = ACTIONS(87),
    [aux_sym_control_escape_token2] = ACTIONS(90),
    [sym_control_letter_escape] = ACTIONS(45),
    [sym_identity_escape] = ACTIONS(93),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 7,
    ACTIONS(100), 1,
      anon_sym_STAR,
    ACTIONS(102), 1,
      anon_sym_QMARK,
    ACTIONS(104), 1,
      anon_sym_PLUS,
    ACTIONS(106), 1,
      anon_sym_LBRACE,
    STATE(57), 4,
      sym_zero_or_more,
      sym_one_or_more,
      sym_optional,
      sym_count_quantifier,
    ACTIONS(98), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(96), 21,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [50] = 2,
    ACTIONS(110), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(108), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [86] = 2,
    ACTIONS(114), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(112), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [122] = 2,
    ACTIONS(118), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(116), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [158] = 2,
    ACTIONS(122), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(120), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [194] = 2,
    ACTIONS(126), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(124), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [230] = 2,
    ACTIONS(130), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(128), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [266] = 2,
    ACTIONS(134), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(132), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [302] = 2,
    ACTIONS(138), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(136), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [338] = 2,
    ACTIONS(142), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(140), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [374] = 2,
    ACTIONS(146), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(144), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [410] = 2,
    ACTIONS(150), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(148), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [446] = 2,
    ACTIONS(154), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(152), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [482] = 2,
    ACTIONS(158), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(156), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [518] = 2,
    ACTIONS(162), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(160), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [554] = 2,
    ACTIONS(166), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(164), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [590] = 2,
    ACTIONS(170), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(168), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [626] = 2,
    ACTIONS(174), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(172), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [662] = 2,
    ACTIONS(178), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(176), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [698] = 2,
    ACTIONS(182), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(180), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [734] = 2,
    ACTIONS(186), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(184), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [770] = 2,
    ACTIONS(190), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(188), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [806] = 2,
    ACTIONS(194), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(192), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [842] = 2,
    ACTIONS(198), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(196), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [878] = 2,
    ACTIONS(202), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(200), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [914] = 2,
    ACTIONS(206), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(204), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [950] = 2,
    ACTIONS(210), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(208), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [986] = 2,
    ACTIONS(214), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(212), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1022] = 2,
    ACTIONS(218), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(216), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1058] = 2,
    ACTIONS(222), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(220), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1094] = 2,
    ACTIONS(226), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(224), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1130] = 2,
    ACTIONS(230), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(228), 25,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1166] = 3,
    ACTIONS(236), 1,
      anon_sym_QMARK,
    ACTIONS(234), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(232), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1201] = 3,
    ACTIONS(242), 1,
      anon_sym_QMARK,
    ACTIONS(240), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(238), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1236] = 3,
    ACTIONS(248), 1,
      anon_sym_QMARK,
    ACTIONS(246), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(244), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1271] = 3,
    ACTIONS(254), 1,
      anon_sym_QMARK,
    ACTIONS(252), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(250), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1306] = 3,
    ACTIONS(260), 1,
      anon_sym_QMARK,
    ACTIONS(258), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(256), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1341] = 3,
    ACTIONS(266), 1,
      anon_sym_QMARK,
    ACTIONS(264), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(262), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1376] = 2,
    ACTIONS(270), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(268), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1408] = 2,
    ACTIONS(274), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(272), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1440] = 2,
    ACTIONS(278), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(276), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1472] = 2,
    ACTIONS(282), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(280), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1504] = 2,
    ACTIONS(286), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(284), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1536] = 2,
    ACTIONS(290), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(288), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1568] = 2,
    ACTIONS(292), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      aux_sym_control_escape_token1,
      sym_identity_escape,
    ACTIONS(43), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARKP_LT,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      anon_sym_LPAREN_QMARKP_EQ,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
  [1600] = 13,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(296), 1,
      anon_sym_DASH,
    ACTIONS(298), 1,
      anon_sym_RBRACK,
    ACTIONS(300), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(304), 1,
      sym_class_character,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(69), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(302), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(60), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1647] = 12,
    ACTIONS(300), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(304), 1,
      sym_class_character,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(314), 1,
      anon_sym_DASH,
    ACTIONS(316), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(69), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(318), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(61), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1691] = 12,
    ACTIONS(300), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(304), 1,
      sym_class_character,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(320), 1,
      anon_sym_DASH,
    ACTIONS(322), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(69), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(318), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(61), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1735] = 12,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(327), 1,
      anon_sym_RBRACK,
    ACTIONS(329), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(335), 1,
      sym_class_character,
    ACTIONS(338), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(341), 1,
      aux_sym_character_class_escape_token2,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(344), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(347), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(69), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(332), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(61), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1779] = 12,
    ACTIONS(300), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(304), 1,
      sym_class_character,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(322), 1,
      anon_sym_RBRACK,
    ACTIONS(350), 1,
      anon_sym_DASH,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(69), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(352), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(66), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1823] = 12,
    ACTIONS(300), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(304), 1,
      sym_class_character,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(354), 1,
      anon_sym_DASH,
    ACTIONS(356), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(69), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(358), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(65), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1867] = 12,
    ACTIONS(300), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(304), 1,
      sym_class_character,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(360), 1,
      anon_sym_DASH,
    ACTIONS(362), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(69), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(364), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(59), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1911] = 12,
    ACTIONS(300), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(304), 1,
      sym_class_character,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(366), 1,
      anon_sym_DASH,
    ACTIONS(368), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(69), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(318), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(61), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1955] = 12,
    ACTIONS(300), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(304), 1,
      sym_class_character,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(370), 1,
      anon_sym_DASH,
    ACTIONS(372), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(69), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(318), 3,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
    STATE(61), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
  [1999] = 9,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(374), 1,
      anon_sym_DASH,
    ACTIONS(378), 1,
      sym_class_character,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(68), 2,
      sym_character_class_escape,
      sym_control_escape,
    ACTIONS(376), 5,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_control_letter_escape,
      sym_identity_escape,
  [2034] = 1,
    ACTIONS(380), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2050] = 2,
    ACTIONS(382), 1,
      anon_sym_DASH,
    ACTIONS(385), 12,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2068] = 1,
    ACTIONS(387), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2084] = 1,
    ACTIONS(389), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2100] = 1,
    ACTIONS(162), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2116] = 1,
    ACTIONS(376), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2132] = 1,
    ACTIONS(110), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2148] = 1,
    ACTIONS(114), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2164] = 1,
    ACTIONS(142), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2180] = 1,
    ACTIONS(190), 13,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
      sym_control_letter_escape,
      sym_identity_escape,
  [2196] = 9,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(391), 1,
      anon_sym_DASH,
    ACTIONS(393), 1,
      anon_sym_RBRACK,
    ACTIONS(395), 1,
      sym_class_character,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(68), 2,
      sym_character_class_escape,
      sym_control_escape,
  [2227] = 9,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(391), 1,
      anon_sym_DASH,
    ACTIONS(395), 1,
      sym_class_character,
    ACTIONS(397), 1,
      anon_sym_RBRACK,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(68), 2,
      sym_character_class_escape,
      sym_control_escape,
  [2258] = 8,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(399), 1,
      anon_sym_DASH,
    ACTIONS(401), 1,
      sym_class_character,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(71), 2,
      sym_character_class_escape,
      sym_control_escape,
  [2286] = 8,
    ACTIONS(306), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(308), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(374), 1,
      anon_sym_DASH,
    ACTIONS(395), 1,
      sym_class_character,
    STATE(74), 1,
      sym_unicode_character_escape,
    ACTIONS(310), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(312), 2,
      aux_sym_control_escape_token1,
      aux_sym_control_escape_token2,
    STATE(68), 2,
      sym_character_class_escape,
      sym_control_escape,
  [2314] = 4,
    ACTIONS(405), 1,
      anon_sym_DASH,
    ACTIONS(407), 1,
      aux_sym_posix_class_name_token1,
    STATE(87), 1,
      sym_flags,
    ACTIONS(403), 2,
      anon_sym_EQ,
      anon_sym_BANG,
  [2328] = 3,
    ACTIONS(411), 1,
      anon_sym_PIPE,
    STATE(83), 1,
      aux_sym_alternation_repeat1,
    ACTIONS(409), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [2339] = 3,
    ACTIONS(3), 1,
      anon_sym_PIPE,
    STATE(83), 1,
      aux_sym_alternation_repeat1,
    ACTIONS(414), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [2350] = 3,
    ACTIONS(3), 1,
      anon_sym_PIPE,
    STATE(84), 1,
      aux_sym_alternation_repeat1,
    ACTIONS(416), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [2361] = 3,
    ACTIONS(3), 1,
      anon_sym_PIPE,
    STATE(83), 1,
      aux_sym_alternation_repeat1,
    ACTIONS(418), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [2372] = 3,
    ACTIONS(420), 1,
      anon_sym_RPAREN,
    ACTIONS(422), 1,
      anon_sym_DASH,
    ACTIONS(424), 1,
      anon_sym_COLON,
  [2382] = 2,
    ACTIONS(428), 1,
      sym_group_name,
    ACTIONS(426), 2,
      anon_sym_EQ,
      anon_sym_BANG,
  [2390] = 1,
    ACTIONS(409), 3,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [2396] = 1,
    ACTIONS(430), 3,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_COLON,
  [2402] = 1,
    ACTIONS(416), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [2407] = 2,
    ACTIONS(432), 1,
      sym_unicode_property,
    STATE(133), 1,
      sym_unicode_property_value_expression,
  [2414] = 2,
    ACTIONS(434), 1,
      anon_sym_DASH,
    ACTIONS(436), 1,
      anon_sym_RBRACK,
  [2421] = 2,
    ACTIONS(432), 1,
      sym_unicode_property,
    STATE(116), 1,
      sym_unicode_property_value_expression,
  [2428] = 2,
    ACTIONS(434), 1,
      anon_sym_DASH,
    ACTIONS(438), 1,
      anon_sym_RBRACK,
  [2435] = 2,
    ACTIONS(440), 1,
      aux_sym_posix_class_name_token1,
    STATE(115), 1,
      sym_posix_class_name,
  [2442] = 2,
    ACTIONS(407), 1,
      aux_sym_posix_class_name_token1,
    STATE(104), 1,
      sym_flags,
  [2449] = 2,
    ACTIONS(442), 1,
      anon_sym_COMMA,
    ACTIONS(444), 1,
      sym_decimal_digits,
  [2456] = 2,
    ACTIONS(434), 1,
      anon_sym_DASH,
    ACTIONS(446), 1,
      anon_sym_RBRACK,
  [2463] = 2,
    ACTIONS(448), 1,
      anon_sym_EQ,
    ACTIONS(450), 1,
      anon_sym_RBRACE,
  [2470] = 2,
    ACTIONS(452), 1,
      anon_sym_RBRACE,
    ACTIONS(454), 1,
      sym_decimal_digits,
  [2477] = 2,
    ACTIONS(456), 1,
      anon_sym_COMMA,
    ACTIONS(458), 1,
      anon_sym_RBRACE,
  [2484] = 2,
    ACTIONS(460), 1,
      anon_sym_RPAREN,
    ACTIONS(462), 1,
      anon_sym_COLON,
  [2491] = 2,
    ACTIONS(464), 1,
      anon_sym_RPAREN,
    ACTIONS(466), 1,
      anon_sym_COLON,
  [2498] = 2,
    ACTIONS(407), 1,
      aux_sym_posix_class_name_token1,
    STATE(103), 1,
      sym_flags,
  [2505] = 2,
    ACTIONS(440), 1,
      aux_sym_posix_class_name_token1,
    STATE(132), 1,
      sym_posix_class_name,
  [2512] = 2,
    ACTIONS(434), 1,
      anon_sym_DASH,
    ACTIONS(468), 1,
      anon_sym_RBRACK,
  [2519] = 1,
    ACTIONS(470), 1,
      anon_sym_RPAREN,
  [2523] = 1,
    ACTIONS(472), 1,
      anon_sym_RPAREN,
  [2527] = 1,
    ACTIONS(474), 1,
      anon_sym_RPAREN,
  [2531] = 1,
    ACTIONS(476), 1,
      anon_sym_LBRACE,
  [2535] = 1,
    ACTIONS(478), 1,
      anon_sym_GT,
  [2539] = 1,
    ACTIONS(480), 1,
      sym_group_name,
  [2543] = 1,
    ACTIONS(482), 1,
      anon_sym_RPAREN,
  [2547] = 1,
    ACTIONS(484), 1,
      anon_sym_COLON_RBRACK,
  [2551] = 1,
    ACTIONS(486), 1,
      anon_sym_RBRACE,
  [2555] = 1,
    ACTIONS(452), 1,
      anon_sym_RBRACE,
  [2559] = 1,
    ACTIONS(434), 1,
      anon_sym_DASH,
  [2563] = 1,
    ACTIONS(488), 1,
      anon_sym_RBRACE,
  [2567] = 1,
    ACTIONS(490), 1,
      sym_decimal_digits,
  [2571] = 1,
    ACTIONS(492), 1,
      anon_sym_GT,
  [2575] = 1,
    ACTIONS(494), 1,
      anon_sym_RPAREN,
  [2579] = 1,
    ACTIONS(496), 1,
      anon_sym_RPAREN,
  [2583] = 1,
    ACTIONS(498), 1,
      sym_group_name,
  [2587] = 1,
    ACTIONS(500), 1,
      sym_unicode_property,
  [2591] = 1,
    ACTIONS(460), 1,
      anon_sym_RPAREN,
  [2595] = 1,
    ACTIONS(502), 1,
      anon_sym_RPAREN,
  [2599] = 1,
    ACTIONS(504), 1,
      anon_sym_RPAREN,
  [2603] = 1,
    ACTIONS(506), 1,
      ts_builtin_sym_end,
  [2607] = 1,
    ACTIONS(508), 1,
      anon_sym_LT,
  [2611] = 1,
    ACTIONS(510), 1,
      anon_sym_COLON_RBRACK,
  [2615] = 1,
    ACTIONS(512), 1,
      anon_sym_COLON_RBRACK,
  [2619] = 1,
    ACTIONS(514), 1,
      anon_sym_RBRACE,
  [2623] = 1,
    ACTIONS(516), 1,
      anon_sym_RBRACE,
  [2627] = 1,
    ACTIONS(428), 1,
      sym_group_name,
  [2631] = 1,
    ACTIONS(518), 1,
      anon_sym_LBRACE,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(13)] = 0,
  [SMALL_STATE(14)] = 50,
  [SMALL_STATE(15)] = 86,
  [SMALL_STATE(16)] = 122,
  [SMALL_STATE(17)] = 158,
  [SMALL_STATE(18)] = 194,
  [SMALL_STATE(19)] = 230,
  [SMALL_STATE(20)] = 266,
  [SMALL_STATE(21)] = 302,
  [SMALL_STATE(22)] = 338,
  [SMALL_STATE(23)] = 374,
  [SMALL_STATE(24)] = 410,
  [SMALL_STATE(25)] = 446,
  [SMALL_STATE(26)] = 482,
  [SMALL_STATE(27)] = 518,
  [SMALL_STATE(28)] = 554,
  [SMALL_STATE(29)] = 590,
  [SMALL_STATE(30)] = 626,
  [SMALL_STATE(31)] = 662,
  [SMALL_STATE(32)] = 698,
  [SMALL_STATE(33)] = 734,
  [SMALL_STATE(34)] = 770,
  [SMALL_STATE(35)] = 806,
  [SMALL_STATE(36)] = 842,
  [SMALL_STATE(37)] = 878,
  [SMALL_STATE(38)] = 914,
  [SMALL_STATE(39)] = 950,
  [SMALL_STATE(40)] = 986,
  [SMALL_STATE(41)] = 1022,
  [SMALL_STATE(42)] = 1058,
  [SMALL_STATE(43)] = 1094,
  [SMALL_STATE(44)] = 1130,
  [SMALL_STATE(45)] = 1166,
  [SMALL_STATE(46)] = 1201,
  [SMALL_STATE(47)] = 1236,
  [SMALL_STATE(48)] = 1271,
  [SMALL_STATE(49)] = 1306,
  [SMALL_STATE(50)] = 1341,
  [SMALL_STATE(51)] = 1376,
  [SMALL_STATE(52)] = 1408,
  [SMALL_STATE(53)] = 1440,
  [SMALL_STATE(54)] = 1472,
  [SMALL_STATE(55)] = 1504,
  [SMALL_STATE(56)] = 1536,
  [SMALL_STATE(57)] = 1568,
  [SMALL_STATE(58)] = 1600,
  [SMALL_STATE(59)] = 1647,
  [SMALL_STATE(60)] = 1691,
  [SMALL_STATE(61)] = 1735,
  [SMALL_STATE(62)] = 1779,
  [SMALL_STATE(63)] = 1823,
  [SMALL_STATE(64)] = 1867,
  [SMALL_STATE(65)] = 1911,
  [SMALL_STATE(66)] = 1955,
  [SMALL_STATE(67)] = 1999,
  [SMALL_STATE(68)] = 2034,
  [SMALL_STATE(69)] = 2050,
  [SMALL_STATE(70)] = 2068,
  [SMALL_STATE(71)] = 2084,
  [SMALL_STATE(72)] = 2100,
  [SMALL_STATE(73)] = 2116,
  [SMALL_STATE(74)] = 2132,
  [SMALL_STATE(75)] = 2148,
  [SMALL_STATE(76)] = 2164,
  [SMALL_STATE(77)] = 2180,
  [SMALL_STATE(78)] = 2196,
  [SMALL_STATE(79)] = 2227,
  [SMALL_STATE(80)] = 2258,
  [SMALL_STATE(81)] = 2286,
  [SMALL_STATE(82)] = 2314,
  [SMALL_STATE(83)] = 2328,
  [SMALL_STATE(84)] = 2339,
  [SMALL_STATE(85)] = 2350,
  [SMALL_STATE(86)] = 2361,
  [SMALL_STATE(87)] = 2372,
  [SMALL_STATE(88)] = 2382,
  [SMALL_STATE(89)] = 2390,
  [SMALL_STATE(90)] = 2396,
  [SMALL_STATE(91)] = 2402,
  [SMALL_STATE(92)] = 2407,
  [SMALL_STATE(93)] = 2414,
  [SMALL_STATE(94)] = 2421,
  [SMALL_STATE(95)] = 2428,
  [SMALL_STATE(96)] = 2435,
  [SMALL_STATE(97)] = 2442,
  [SMALL_STATE(98)] = 2449,
  [SMALL_STATE(99)] = 2456,
  [SMALL_STATE(100)] = 2463,
  [SMALL_STATE(101)] = 2470,
  [SMALL_STATE(102)] = 2477,
  [SMALL_STATE(103)] = 2484,
  [SMALL_STATE(104)] = 2491,
  [SMALL_STATE(105)] = 2498,
  [SMALL_STATE(106)] = 2505,
  [SMALL_STATE(107)] = 2512,
  [SMALL_STATE(108)] = 2519,
  [SMALL_STATE(109)] = 2523,
  [SMALL_STATE(110)] = 2527,
  [SMALL_STATE(111)] = 2531,
  [SMALL_STATE(112)] = 2535,
  [SMALL_STATE(113)] = 2539,
  [SMALL_STATE(114)] = 2543,
  [SMALL_STATE(115)] = 2547,
  [SMALL_STATE(116)] = 2551,
  [SMALL_STATE(117)] = 2555,
  [SMALL_STATE(118)] = 2559,
  [SMALL_STATE(119)] = 2563,
  [SMALL_STATE(120)] = 2567,
  [SMALL_STATE(121)] = 2571,
  [SMALL_STATE(122)] = 2575,
  [SMALL_STATE(123)] = 2579,
  [SMALL_STATE(124)] = 2583,
  [SMALL_STATE(125)] = 2587,
  [SMALL_STATE(126)] = 2591,
  [SMALL_STATE(127)] = 2595,
  [SMALL_STATE(128)] = 2599,
  [SMALL_STATE(129)] = 2603,
  [SMALL_STATE(130)] = 2607,
  [SMALL_STATE(131)] = 2611,
  [SMALL_STATE(132)] = 2615,
  [SMALL_STATE(133)] = 2619,
  [SMALL_STATE(134)] = 2623,
  [SMALL_STATE(135)] = 2627,
  [SMALL_STATE(136)] = 2631,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [39] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternation_repeat1, 1, 0, 0),
  [41] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_term, 1, 0, 0),
  [43] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0),
  [45] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(13),
  [48] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(17),
  [51] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(82),
  [54] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [57] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(58),
  [60] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(96),
  [63] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(5),
  [66] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(135),
  [69] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(4),
  [72] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(130),
  [75] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(124),
  [78] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(14),
  [81] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(111),
  [84] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(27),
  [87] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(15),
  [90] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(15),
  [93] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(13),
  [96] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 1, 0, 0),
  [98] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 1, 0, 0),
  [100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class_escape, 1, 0, 0),
  [110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class_escape, 1, 0, 0),
  [112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_control_escape, 1, 0, 0),
  [114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_control_escape, 1, 0, 0),
  [116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookaround_assertion, 1, 0, 0),
  [118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookaround_assertion, 1, 0, 0),
  [120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_start_assertion, 1, 0, 0),
  [122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_start_assertion, 1, 0, 0),
  [124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 2, 0, 0),
  [126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 2, 0, 0),
  [128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_flags_group, 3, 0, 0),
  [130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_flags_group, 3, 0, 0),
  [132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 3, 0, 0),
  [134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 3, 0, 0),
  [136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 3, 0, 2),
  [138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 3, 0, 2),
  [140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_posix_character_class, 3, 0, 0),
  [142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_posix_character_class, 3, 0, 0),
  [144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_capturing_group, 3, 0, 0),
  [146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_capturing_group, 3, 0, 0),
  [148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_capturing_group, 3, 0, 0),
  [150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_capturing_group, 3, 0, 0),
  [152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_group_backreference, 3, 0, 0),
  [154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_group_backreference, 3, 0, 0),
  [156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lookahead_assertion, 4, 0, 0),
  [158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lookahead_assertion, 4, 0, 0),
  [160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_character_escape, 1, 0, 0),
  [162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unicode_character_escape, 1, 0, 0),
  [164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lookbehind_assertion, 4, 0, 0),
  [166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lookbehind_assertion, 4, 0, 0),
  [168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 4, 0, 3),
  [170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 4, 0, 3),
  [172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 4, 0, 0),
  [174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 4, 0, 0),
  [176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 4, 0, 5),
  [178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 4, 0, 5),
  [180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 4, 0, 2),
  [182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 4, 0, 2),
  [184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_backreference_escape, 4, 0, 0),
  [186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_backreference_escape, 4, 0, 0),
  [188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class_escape, 4, 0, 0),
  [190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class_escape, 4, 0, 0),
  [192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_flags_group, 5, 0, 0),
  [194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_flags_group, 5, 0, 0),
  [196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_capturing_group, 5, 0, 0),
  [198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_capturing_group, 5, 0, 0),
  [200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 5, 0, 8),
  [202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 5, 0, 8),
  [204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 5, 0, 3),
  [206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 5, 0, 3),
  [208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 5, 0, 9),
  [210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 5, 0, 9),
  [212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 5, 0, 10),
  [214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 5, 0, 10),
  [216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_flags_group, 6, 0, 0),
  [218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_flags_group, 6, 0, 0),
  [220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 6, 0, 13),
  [222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 6, 0, 13),
  [224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_flags_group, 7, 0, 0),
  [226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_flags_group, 7, 0, 0),
  [228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_flags_group, 4, 0, 0),
  [230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_flags_group, 4, 0, 0),
  [232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 5, 0, 0),
  [234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 5, 0, 0),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional, 1, 0, 0),
  [240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional, 1, 0, 0),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_one_or_more, 1, 0, 0),
  [246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_one_or_more, 1, 0, 0),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 3, 0, 0),
  [252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 3, 0, 0),
  [254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 4, 0, 0),
  [258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 4, 0, 0),
  [260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_zero_or_more, 1, 0, 0),
  [264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_zero_or_more, 1, 0, 0),
  [266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 5, 0, 12),
  [270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 5, 0, 12),
  [272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 6, 0, 14),
  [274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 6, 0, 14),
  [276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 4, 0, 7),
  [278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 4, 0, 7),
  [280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_zero_or_more, 2, 0, 1),
  [282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_zero_or_more, 2, 0, 1),
  [284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional, 2, 0, 1),
  [286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional, 2, 0, 1),
  [288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_one_or_more, 2, 0, 1),
  [290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_one_or_more, 2, 0, 1),
  [292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0),
  [294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(118),
  [327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(106),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(61),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(69),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(74),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(136),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(72),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(75),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_range, 3, 0, 4),
  [378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_range, 3, 0, 6),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 1, 0, 0), SHIFT(80),
  [385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 1, 0, 0),
  [387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_range, 3, 0, 3),
  [389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_range, 3, 0, 0),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternation_repeat1, 2, 0, 0),
  [411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternation_repeat1, 2, 0, 0), SHIFT_REPEAT(10),
  [414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternation, 2, 0, 0),
  [416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternation, 1, 0, 0),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flags, 1, 0, 0),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_property_value_expression, 1, 0, 0),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_property_value_expression, 3, 0, 11),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [506] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_posix_class_name, 1, 0, 0),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_regex(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
